VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Instrumenter"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

'Output to Windows debugger
Private Declare Sub OutputDebugString Lib "kernel32" Alias "OutputDebugStringA" (ByVal lpOutputString As String)

Private mInstrumenterMode  As InstrumenterMode
Private msLogFile As String

Public Enum InstrumenterMode
    none = 0
    DebugWindow_VBONLY = 1
    OutputDebugStringAPI = 2
    ToFile = 3
End Enum

Private Sub Class_Initialize()
On Error Resume Next
    'Set Defaults Values
    mInstrumenterMode = RetrieveDebugModeFromRegistry
    msLogFile = "C:\SmartTagInstrumenter.log"
End Sub

Public Property Get Mode() As InstrumenterMode
On Error Resume Next
    Mode = mInstrumenterMode
End Property

Public Property Let Mode(ByVal vNewValue As InstrumenterMode)
On Error Resume Next
    If vNewValue <= 3 And vNewValue >= 0 Then
        mInstrumenterMode = vNewValue
        SaveSetting "SmartTagInstrumenter", "Debug", "Mode", CStr(mInstrumenterMode)
    Else
        mInstrumenterMode = 0
        SaveSetting "SmartTagInstrumenter", "Debug", "Mode", "0"
    End If
End Property

Public Sub Log(ByRef sMSG As String)
On Error GoTo ErrorHandler
'Log an item to the Log Device
    Select Case mInstrumenterMode
        Case none
            Exit Sub
        Case DebugWindow_VBONLY
            Debug.Print sMSG
        Case OutputDebugStringAPI
            'Standard WIN32 Debug API call
            OutputDebugString sMSG
        Case ToFile
            SaveLogMsgToFile sMSG
        Case Else
            Exit Sub
    End Select
Finally:
    Exit Sub
ErrorHandler:
    OutputDebugString "Logging Error: " & Err.Number & "-" & Err.Description
    GoTo Finally
End Sub

Private Sub SaveLogMsgToFile(ByRef sMSG)
'Save Log Item to file
On Error GoTo ERR_SaveLogMsgToFile
    Open msLogFile For Append As #1
    Write #1, Now(), sMSG
    Close #1
Finally:
    Exit Sub
ERR_SaveLogMsgToFile:
    'Problem logging to file, deactive Instrumentation
    mInstrumenterMode = none
    GoTo Finally
End Sub

Private Function RetrieveDebugModeFromRegistry()
    RetrieveDebugModeFromRegistry = CStr(GetSetting("SmartTagInstrumenter", "Debug", "Mode", "0"))
End Function

