VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Recognizer"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit
Option Compare Text

Implements SmartTagLib.ISmartTagRecognizer

Private Sub Class_Initialize()
On Error GoTo ErrorHandler
  'Initialize doesnt do anything, but we want to see
  'when this object is initialized in Instrumenter
  gLog.Log "Recognizer Class Initialize"
Finally:
  Exit Sub
ErrorHandler:
  gLog.Log "ERROR: " & Err.Number & " " & Err.Description
  GoTo Finally
End Sub

Private Sub Class_Terminate()
On Error GoTo ErrorHandler
  'Terminate doesnt do anything, but we want to see
  'when this object is Terminate in Instrumenter
  gLog.Log "Recognizer Class Terminate"
Finally:
  Exit Sub
ErrorHandler:
  gLog.Log "ERROR: " & Err.Number & " " & Err.Description
  GoTo Finally
End Sub

Private Property Get ISmartTagRecognizer_Desc(ByVal LocaleID As Long) As String
On Error GoTo ErrorHandler
  'Description of the Smart Tag
  gLog.Log "Recognizer Desc:" & gsST_Description
  ISmartTagRecognizer_Desc = gsST_Description
Finally:
  Exit Sub
ErrorHandler:
  gLog.Log "ERROR: " & Err.Number & " " & Err.Description
  GoTo Finally
End Property

Private Property Get ISmartTagRecognizer_Name(ByVal LocaleID As Long) As String
On Error GoTo ErrorHandler
  'Smart Tag Name
  gLog.Log "Recognizer Name:" & gsST_Name
  ISmartTagRecognizer_Name = gsST_Name
Finally:
  Exit Sub
ErrorHandler:
  gLog.Log "ERROR: " & Err.Number & " " & Err.Description
  GoTo Finally
End Property

Private Property Get ISmartTagRecognizer_ProgId() As String
On Error GoTo ErrorHandler
  'ProgID for recognizer DLL (DLLName.ClassName)
  gLog.Log "Recognizer ProgID:" & gsST_ProgIDRecognizer
  ISmartTagRecognizer_ProgId = gsST_ProgIDRecognizer
Finally:
  Exit Sub
ErrorHandler:
  gLog.Log "ERROR: " & Err.Number & " " & Err.Description
  GoTo Finally
End Property

Private Sub ISmartTagRecognizer_Recognize(ByVal Text As String, ByVal DataType As SmartTagLib.IF_TYPE, ByVal LocaleID As Long, ByVal RecognizerSite As SmartTagLib.ISmartTagRecognizerSite)
On Error GoTo ErrorHandler
  'Text is passed into the Recognize method.
  'This is where we analyze the text for terms
  'we want to recognize
  gLog.Log "Recognizer Recognize:" & Text
  glST_SessionRecognizerScans = glST_SessionRecognizerScans + 1
  
  Dim regSearch As Object
  Dim kba As Object 'RegExp Match
  Dim kbc As Object 'RegExp MatchCollection Object
  Dim stProperties As SmartTagLib.ISmartTagProperties
  Dim lSTInst As Long
  
  Set regSearch = CreateObject("VBScript.RegExp")
  
  'Search for KB Article
  With regSearch
    .IgnoreCase = True
    .Global = True
    .Pattern = "Q[0-9]{5,6}\b"
  End With
  
  Set kbc = regSearch.Execute(Text)

  For Each kba In kbc
    gLog.Log "** RECOGNIZED: " & kba.Value
    glST_SessionTermsRecognized = glST_SessionTermsRecognized + 1
    Set stProperties = RecognizerSite.GetNewPropertyBag
    stProperties.Write "KBArticle", kba.Value
    RecognizerSite.CommitSmartTag gsST_Types(0), kba.FirstIndex + 1, kba.Length, stProperties
  Next

  'Search for Instrumentation Smart Tag
  lSTInst = InStr(1, Text, "_STINSTRUMENTMODE_")
  If lSTInst > 0 Then
    gLog.Log "** RECOGNIZED: _STINSTRUMENTMODE_"
    glST_SessionTermsRecognized = glST_SessionTermsRecognized + 1
    Set stProperties = RecognizerSite.GetNewPropertyBag
    RecognizerSite.CommitSmartTag gsST_Types(1), lSTInst, 18, stProperties
  End If

Finally:
  Exit Sub
ErrorHandler:
  gLog.Log "ERROR: " & Err.Number & " " & Err.Description
  GoTo Finally
End Sub

Private Property Get ISmartTagRecognizer_SmartTagCount() As Long
On Error GoTo ErrorHandler
  'How many types (unique) smart tags reocgnized
  gLog.Log "Recognizer Count:" & giST_Count
  ISmartTagRecognizer_SmartTagCount = giST_Count
Finally:
  Exit Sub
ErrorHandler:
  gLog.Log "ERROR: " & Err.Number & " " & Err.Description
  Resume Next
End Property

Private Property Get ISmartTagRecognizer_SmartTagDownloadURL(ByVal SmartTagID As Long) As String
On Error GoTo ErrorHandler
  'Download URL for updates to this smart tag
  'Blank if there is no Download URL
  gLog.Log "Recognizer DownloadURL:" & gsST_DownloadURL
  ISmartTagRecognizer_SmartTagDownloadURL = gsST_DownloadURL
Finally:
  Exit Sub
ErrorHandler:
  gLog.Log "ERROR: " & Err.Number & " " & Err.Description
  GoTo Finally
End Property

Private Property Get ISmartTagRecognizer_SmartTagName(ByVal SmartTagID As Long) As String
On Error GoTo ErrorHandler
  'Individual Type Name for each unique smart tag
  'recognized in this DLL
  gLog.Log "Recognizer SmartTagname: " & gsST_Types(SmartTagID - 1)
  ISmartTagRecognizer_SmartTagName = gsST_Types(SmartTagID - 1)
Finally:
  Exit Sub
ErrorHandler:
  gLog.Log "ERROR: " & Err.Number & " " & Err.Description
  GoTo Finally
End Property
