Attribute VB_Name = "basGlobals"
Option Explicit

'Global SmartTag Property settings

Public Const gsST_Name As String = "MS KB Article Lookup (OfficeZealot.com)"
Public Const gsST_Description As String = "Microsoft Knowledgebase Article look up Smart Tag"
Public Const gsST_ProgIDRecognizer As String = "MSKBArticle.Recognizer"
Public Const gsST_ProgIDActions  As String = "MSKBArticle.Actions"
Public Const gsST_DownloadURL  As String = "http://www.officezealot.com/smarttags"
Public Const gsST_Namespace  As String = "urn:schemas-officezealot-com:KBArticle"
Public Const giST_Count As Integer = 2  'How many types supported
Public gsST_Types() As String
Public gsST_TypesFriendlyNames() As String
Public gLog As Instrumenter 'Instrumenting Device for DLL

'Global Status Information (Used for dumping status of SmartTag to the log)
Public gsST_SessionStartTime As String
Public glST_SessionRecognizerScans As Long
Public glST_SessionTermsRecognized As Long
Public glST_SessionActionsInvoked As Long

Sub Main()
'Initalize Global Data
On Error GoTo ErrorHandler
  
  'Session Info
  gsST_SessionStartTime = Now()
  glST_SessionRecognizerScans = 0
  glST_SessionTermsRecognized = 0
  glST_SessionActionsInvoked = 0
  
  'Initalize Instrumentation
  Set gLog = New Instrumenter
  gLog.Log App.EXEName & " STARTUP -------------"
  
  'Declare Namespace types
  ReDim gsST_Types(giST_Count - 1)
  gsST_Types(0) = gsST_Namespace & "#QNumber"
  gsST_Types(1) = gsST_Namespace & "#STINSTRUMENTMODE"
  
  'Friendly Name for Types
  ReDim gsST_TypesFriendlyNames(giST_Count - 1)
  gsST_TypesFriendlyNames(0) = "MS KB Article Lookup"
  gsST_TypesFriendlyNames(1) = "&SmartTag Instrument Mode"
  
Finally:
  Exit Sub
ErrorHandler:
  GoTo Finally
End Sub

Public Sub SmartTagStatusDump()
'Dump internal smart tag info to log
On Error Resume Next
  Dim iCounter As Integer
  With gLog
    .Log "-------** START: SmartTag Status Dump **-------"
    .Log "SmartTag Name:               " & gsST_Name
    .Log "SmartTag Desc:               " & gsST_Description
    .Log "SmartTag Recognizer ProdID:  " & gsST_ProgIDRecognizer
    .Log "SmartTag Action ProgID:      " & gsST_ProgIDActions
    .Log "SmartTag DownloadURL:        " & gsST_DownloadURL
    .Log "SmartTag Namespace:          " & gsST_Namespace
    .Log "SmartTag Count:              " & giST_Count
    .Log "SmartTag XML Data Path:      " & App.Path
  
    Select Case .Mode
      Case 0 'None
        .Log "Instrument Mode:             None"
      Case 1 'DebugWindow_VBONLY
        .Log "Instrument Mode:             DebugWindow_VBONLY"
      Case 2 'OutPutDebugString
        .Log "Instrument Mode:             OutputDebugString"
      Case 3 'To File
        .Log "Instrument Mode:             ToFile"
    End Select
    
    .Log "Types-------"
    For iCounter = 0 To UBound(gsST_Types)
    .Log "  (" & iCounter & "): " & gsST_Types(iCounter) & _
         " -Friendly Name is '" & gsST_TypesFriendlyNames(iCounter) & "'"
    Next
      .Log "Session Stats-------"
      .Log "  Start Time:       " & gsST_SessionStartTime
      .Log "  Recognizer Scans: " & glST_SessionRecognizerScans
      .Log "  Terms Recognized: " & glST_SessionTermsRecognized
      .Log "  Actions Invoked:  " & glST_SessionActionsInvoked
      .Log "-------** END: SmartTag Status Dump **-------"
  End With
End Sub

Public Sub ACTION_IELaunchBrowser(sURL As String)
'Launch Internet Explorer to to sURL
On Error GoTo ErrorHandler
  'Launch a web page
  Dim oIE As Object
  Set oIE = CreateObject("InternetExplorer.Application")
  With oIE
    .Navigate2 (sURL)
    .Visible = True
  End With
Finally:
  Set oIE = Nothing
  Exit Sub
ErrorHandler:
  MsgBox "Error with Internet Explorer: " & Err.Number & "-" & Err.Description
  gLog.Log "ACTION_IELaunchBrowser: " & Err.Number & "-" & Err.Description
  GoTo Finally
End Sub
